Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 7773)
@@ -44,5 +44,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
-   !! $Id$
+   !! $Id: ldfdyn_oce.F90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 7773)
@@ -7,5 +7,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldfdyn_substitute.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv_substitute.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv_substitute.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv_substitute.h90	(revision 7773)
@@ -8,5 +8,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldfeiv_substitute.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c1d.h90	(revision 7773)
@@ -5,5 +5,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldftra_c1d.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c2d.h90	(revision 7773)
@@ -5,5 +5,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldftra_c2d.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_c3d.h90	(revision 7773)
@@ -5,5 +5,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldftra_c3d.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_oce.F90	(revision 7773)
@@ -83,5 +83,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldftra_oce.F90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/LDF/ldftra_substitute.h90	(revision 7773)
@@ -7,5 +7,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
-   !! $Id$
+   !! $Id: ldftra_substitute.h90 7740 2017-02-27 13:18:43Z mattmartin $
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 7773)
@@ -27,4 +27,5 @@
    USE obs_grid                 ! Grid searching
    USE obs_read_altbias         ! Bias treatment for altimeter
+   USE obs_sstbias              ! Bias correction routine for SST
    USE obs_profiles_def         ! Profile data definitions
    USE obs_surf_def             ! Surface data definitions
@@ -76,4 +77,6 @@
    !!----------------------------------------------------------------------
 
+   !! * Substitutions 
+#  include "domzgr_substitute.h90"
 CONTAINS
 
@@ -93,4 +96,5 @@
       !!        !  06-10  (A. Weaver) Cleaning and add controls
       !!        !  07-03  (K. Mogensen) General handling of profiles
+      !!        !  14-08  (J.While) Incorporated SST bias correction
       !!        !  15-02  (M. Martin) Simplification of namelist and code
       !!----------------------------------------------------------------------
@@ -108,13 +112,22 @@
       INTEGER :: jvar            ! Counter for variables
       INTEGER :: jfile           ! Counter for files
+      INTEGER :: jnumsstbias     ! Number of SST bias files to read and apply
 
       CHARACTER(len=128), DIMENSION(jpmaxnfiles) :: &
-         & cn_profbfiles, &      ! T/S profile input filenames
-         & cn_sstfbfiles, &      ! Sea surface temperature input filenames
-         & cn_slafbfiles, &      ! Sea level anomaly input filenames
-         & cn_sicfbfiles, &      ! Seaice concentration input filenames
-         & cn_velfbfiles         ! Velocity profile input filenames
+         & cn_profbfiles,    &   ! T/S profile input filenames
+         & cn_sstfbfiles,    &   ! Sea surface temperature input filenames
+         & cn_slafbfiles,    &   ! Sea level anomaly input filenames
+         & cn_sicfbfiles,    &   ! Seaice concentration input filenames
+         & cn_velfbfiles     &   ! Velocity profile input filenames
+         & cn_sssfbfiles,    &   ! Sea surface salinity input filenames
+         & cn_logchlfbfiles, &   ! Log(Chl) input filenames
+         & cn_spmfbfiles,    &   ! Sediment input filenames
+         & cn_fco2fbfiles,   &   ! fco2 input filenames
+         & cn_pco2fbfiles,   &   ! pco2 input filenames
+         & cn_sstbiasfiles       ! SST bias input filenames
+
       CHARACTER(LEN=128) :: &
          & cn_altbiasfile        ! Altimeter bias input filename
+
       CHARACTER(len=128), DIMENSION(:,:), ALLOCATABLE :: &
          & clproffiles, &        ! Profile filenames
@@ -126,9 +139,16 @@
       LOGICAL :: ln_sst          ! Logical switch for sea surface temperature
       LOGICAL :: ln_sic          ! Logical switch for sea ice concentration
+      LOGICAL :: ln_sss          ! Logical switch for sea surface salinity obs
       LOGICAL :: ln_vel3d        ! Logical switch for velocity (u,v) obs
+      LOGICAL :: ln_logchl       ! Logical switch for log(Chl) obs
+      LOGICAL :: ln_spm          ! Logical switch for sediment obs
+      LOGICAL :: ln_fco2         ! Logical switch for fco2 obs
+      LOGICAL :: ln_pco2         ! Logical switch for pco2 obs
       LOGICAL :: ln_nea          ! Logical switch to remove obs near land
       LOGICAL :: ln_altbias      ! Logical switch for altimeter bias
+      LOGICAL :: ln_sstbias      ! Logical switch for bias correction of SST
       LOGICAL :: ln_ignmis       ! Logical switch for ignoring missing files
       LOGICAL :: ln_s_at_t       ! Logical switch to compute model S at T obs
+      LOGICAL :: ln_bound_reject ! Logical switch for rejecting obs near the boundary
       LOGICAL :: llvar1          ! Logical for profile variable 1
       LOGICAL :: llvar2          ! Logical for profile variable 1
@@ -148,11 +168,17 @@
 
       NAMELIST/namobs/ln_diaobs, ln_t3d, ln_s3d, ln_sla,              &
-         &            ln_sst, ln_sic, ln_vel3d,                       &
-         &            ln_altbias, ln_nea, ln_grid_global,             &
-         &            ln_grid_search_lookup,                          &
-         &            ln_ignmis, ln_s_at_t, ln_sstnight,              &
+         &            ln_sst, ln_sic, ln_sss, ln_vel3d,               &
+         &            ln_logchl, ln_spm, ln_fco2, ln_pco2,            &
+         &            ln_altbias, ln_sstbias, ln_nea,                 &
+         &            ln_grid_global, ln_grid_search_lookup,          &
+         &            ln_ignmis, ln_s_at_t, ln_bound_reject,          &
+
+ln_sstnight,              &
          &            cn_profbfiles, cn_slafbfiles,                   &
          &            cn_sstfbfiles, cn_sicfbfiles,                   &
-         &            cn_velfbfiles, cn_altbiasfile,                  &
+         &            cn_velfbfiles, cn_sssfbfiles,                   &
+         &            cn_logchlfbfiles, cn_spmfbfiles,                &
+         &            cn_fco2fbfiles, cn_pco2fbfiles,                 &
+         &            cn_sstbiasfiles, cn_altbiasfile,                &
          &            cn_gridsearchfile, rn_gridsearchres,            &
          &            rn_dobsini, rn_dobsend, nn_1dint, nn_2dint,     &
@@ -172,10 +198,16 @@
 
       ! Some namelist arrays need initialising
-      cn_profbfiles(:) = ''
-      cn_slafbfiles(:) = ''
-      cn_sstfbfiles(:) = ''
-      cn_sicfbfiles(:) = ''
-      cn_velfbfiles(:) = ''
-      nn_profdavtypes(:) = -1
+      cn_profbfiles(:)    = ''
+      cn_slafbfiles(:)    = ''
+      cn_sstfbfiles(:)    = ''
+      cn_sicfbfiles(:)    = ''
+      cn_velfbfiles(:)    = ''
+      cn_sssfbfiles(:)    = ''
+      cn_logchlfbfiles(:) = ''
+      cn_spmfbfiles(:)    = ''
+      cn_fco2fbfiles(:)   = ''
+      cn_pco2fbfiles(:)   = ''
+      cn_sstbiasfiles(:)  = ''
+      nn_profdavtypes(:)  = -1
 
       CALL ini_date( rn_dobsini )
@@ -204,5 +236,6 @@
 
       nproftypes = COUNT( (/ln_t3d .OR. ln_s3d, ln_vel3d /) )
-      nsurftypes = COUNT( (/ln_sla, ln_sst, ln_sic /) )
+      nsurftypes = COUNT( (/ln_sla, ln_sst, ln_sic, ln_sss, &
+         &                  ln_logchl, ln_spm, ln_fco2, ln_pco2 /) )
 
       IF ( nproftypes == 0 .AND. nsurftypes == 0 ) THEN
@@ -285,4 +318,58 @@
          ENDIF
 #endif
+         IF (ln_sss) THEN
+            jtype = jtype + 1
+            clsurffiles(jtype,:) = cn_sssfbfiles(:)
+            cobstypessurf(jtype) = 'sss   '
+            ifilessurf(jtype) = 0
+            DO jfile = 1, jpmaxnfiles
+               IF ( trim(clsurffiles(jtype,jfile)) /= '' ) &
+                  ifilessurf(jtype) = ifilessurf(jtype) + 1
+            END DO
+         ENDIF
+
+         IF (ln_logchl) THEN
+            jtype = jtype + 1
+            clsurffiles(jtype,:) = cn_logchlfbfiles(:)
+            cobstypessurf(jtype) = 'logchl'
+            ifilessurf(jtype) = 0
+            DO jfile = 1, jpmaxnfiles
+               IF ( trim(clsurffiles(jtype,jfile)) /= '' ) &
+                  ifilessurf(jtype) = ifilessurf(jtype) + 1
+            END DO
+         ENDIF
+
+         IF (ln_spm) THEN
+            jtype = jtype + 1
+            clsurffiles(jtype,:) = cn_spmfbfiles(:)
+            cobstypessurf(jtype) = 'spm   '
+            ifilessurf(jtype) = 0
+            DO jfile = 1, jpmaxnfiles
+               IF ( trim(clsurffiles(jtype,jfile)) /= '' ) &
+                  ifilessurf(jtype) = ifilessurf(jtype) + 1
+            END DO
+         ENDIF
+
+         IF (ln_fco2) THEN
+            jtype = jtype + 1
+            clsurffiles(jtype,:) = cn_fco2fbfiles(:)
+            cobstypessurf(jtype) = 'fco2  '
+            ifilessurf(jtype) = 0
+            DO jfile = 1, jpmaxnfiles
+               IF ( trim(clsurffiles(jtype,jfile)) /= '' ) &
+                  ifilessurf(jtype) = ifilessurf(jtype) + 1
+            END DO
+         ENDIF
+
+         IF (ln_pco2) THEN
+            jtype = jtype + 1
+            clsurffiles(jtype,:) = cn_pco2fbfiles(:)
+            cobstypessurf(jtype) = 'pco2  '
+            ifilessurf(jtype) = 0
+            DO jfile = 1, jpmaxnfiles
+               IF ( trim(clsurffiles(jtype,jfile)) /= '' ) &
+                  ifilessurf(jtype) = ifilessurf(jtype) + 1
+            END DO
+         ENDIF
 
       ENDIF
@@ -300,4 +387,9 @@
          WRITE(numout,*) '             Logical switch for Sea Ice observations                  ln_sic = ', ln_sic
          WRITE(numout,*) '             Logical switch for velocity observations               ln_vel3d = ', ln_vel3d
+         WRITE(numout,*) '             Logical switch for SSS observations                      ln_sss = ', ln_sss
+         WRITE(numout,*) '             Logical switch for log(Chl) observations              ln_logchl = ', ln_logchl
+         WRITE(numout,*) '             Logical switch for SPM observations                      ln_spm = ', ln_spm
+         WRITE(numout,*) '             Logical switch for FCO2 observations                    ln_fco2 = ', ln_fco2
+         WRITE(numout,*) '             Logical switch for PCO2 observations                    ln_pco2 = ', ln_pco2
          WRITE(numout,*) '             Global distribution of observations              ln_grid_global = ',ln_grid_global
          WRITE(numout,*) '             Logical switch for obs grid search lookup ln_grid_search_lookup = ',ln_grid_search_lookup
@@ -309,8 +401,10 @@
          WRITE(numout,*) '             Type of horizontal interpolation method                nn_2dint = ', nn_2dint
          WRITE(numout,*) '             Rejection of observations near land switch               ln_nea = ', ln_nea
+         WRITE(numout,*) '             Rejection of obs near open bdys                 ln_bound_reject = ', ln_bound_reject
          WRITE(numout,*) '             MSSH correction scheme                                 nn_msshc = ', nn_msshc
          WRITE(numout,*) '             MDT  correction                                      rn_mdtcorr = ', rn_mdtcorr
          WRITE(numout,*) '             MDT cutoff for computed correction                 rn_mdtcutoff = ', rn_mdtcutoff
          WRITE(numout,*) '             Logical switch for alt bias                          ln_altbias = ', ln_altbias
+         WRITE(numout,*) '             Logical switch for sst bias                          ln_sstbias = ', ln_sstbias
          WRITE(numout,*) '             Logical switch for ignoring missing files             ln_ignmis = ', ln_ignmis
          WRITE(numout,*) '             Daily average types                             nn_profdavtypes = ', nn_profdavtypes
@@ -418,5 +512,6 @@
                &               jpi, jpj, jpk, &
                &               zmask1, zglam1, zgphi1, zmask2, zglam2, zgphi2,  &
-               &               ln_nea, kdailyavtypes = nn_profdavtypes )
+               &               ln_nea, ln_bound_reject, &
+               &               kdailyavtypes = nn_profdavtypes )
 
          END DO
@@ -447,5 +542,5 @@
                &               rn_dobsini, rn_dobsend, ln_ignmis, .FALSE., llnightav )
 
-            CALL obs_pre_surf( surfdata(jtype), surfdataqc(jtype), ln_nea )
+            CALL obs_pre_surf( surfdata(jtype), surfdataqc(jtype), ln_nea, ln_bound_reject )
 
             IF ( TRIM(cobstypessurf(jtype)) == 'sla' ) THEN
@@ -453,4 +548,18 @@
                IF ( ln_altbias ) CALL obs_rea_altbias ( surfdataqc(jtype), nn_2dint, cn_altbiasfile )
             ENDIF
+
+            IF ( TRIM(cobstypessurf(jtype)) == 'sst' .AND. ln_sstbias ) THEN
+               jnumsstbias = 0
+               DO jfile = 1, jpmaxnfiles
+                  IF ( TRIM(cn_sstbiasfiles(jfile)) /= '' ) &
+                  jnumsstbias = jnumsstbias + 1
+               END DO
+               IF ( jnumsstbias == 0 ) THEN
+                  CALL ctl_stop("ln_sstbias set,"// & 
+                     &          "  but no bias files to read in")    
+               ENDIF
+
+               CALL obs_app_sstbias( surfdataqc(jtype), nn_2dint, & 
+                  &                  jnumsstbias, cn_sstbiasfiles(1:jnumsstbias) ) 
 
          END DO
@@ -507,4 +616,27 @@
          & frld
 #endif
+#if defined key_hadocc
+      USE trc, ONLY :  &                ! HadOCC chlorophyll, fCO2 and pCO2
+         & HADOCC_CHL, &
+         & HADOCC_FCO2, &
+         & HADOCC_PCO2, &
+         & HADOCC_FILL_FLT
+#elif defined key_medusa && defined key_foam_medusa
+      USE trc, ONLY :  &                ! MEDUSA chlorophyll, fCO2 and pCO2
+         & MEDUSA_CHL, &
+         & MEDUSA_FCO2, &
+         & MEDUSA_PCO2, &
+         & MEDUSA_FILL_FLT
+#elif defined key_fabm
+      USE fabm
+      USE par_fabm
+#endif
+#if defined key_spm
+      USE par_spm, ONLY: &              ! ERSEM/SPM sediments
+         & jp_spm
+      USE trc, ONLY :  &
+         & trn
+#endif
+
       IMPLICIT NONE
 
@@ -523,5 +655,6 @@
          & zprofmask2              ! Mask associated with zprofvar2
       REAL(wp), POINTER, DIMENSION(:,:) :: &
-         & zsurfvar                ! Model values equivalent to surface ob.
+         & zsurfvar, &             ! Model values equivalent to surface ob.
+         & zsurfmask               ! Mask associated with surface variable
       REAL(wp), POINTER, DIMENSION(:,:) :: &
          & zglam1,    &            ! Model longitudes for prof variable 1
@@ -540,4 +673,5 @@
       CALL wrk_alloc( jpi, jpj, jpk, zprofmask2 )
       CALL wrk_alloc( jpi, jpj, zsurfvar )
+      CALL wrk_alloc( jpi, jpj, zsurfmask )
       CALL wrk_alloc( jpi, jpj, zglam1 )
       CALL wrk_alloc( jpi, jpj, zglam2 )
@@ -608,4 +742,8 @@
          DO jtype = 1, nsurftypes
 
+            !Defaults which might be changed
+            zsurfmask(:,:) = tmask(:,:,1)
+            llnightav = .FALSE.
+
             SELECT CASE ( TRIM(cobstypessurf(jtype)) )
             CASE('sst')
@@ -614,5 +752,6 @@
             CASE('sla')
                zsurfvar(:,:) = sshn(:,:)
-               llnightav = .FALSE.
+            CASE('sss')
+               zsurfvar(:,:) = tsn(:,:,1,jp_sal)
 #if defined key_lim2 || defined key_lim3
             CASE('sic')
@@ -630,11 +769,118 @@
                   zsurfvar(:,:) = 1._wp - frld(:,:)
                ENDIF
-
+#endif
+            CASE('logchl')
+#if defined key_hadocc
+               zsurfvar(:,:) = HADOCC_CHL(:,:,1)    ! (not log) chlorophyll from HadOCC
+#elif defined key_medusa && defined key_foam_medusa
+               zsurfvar(:,:) = MEDUSA_CHL(:,:,1)    ! (not log) chlorophyll from HadOCC
+#elif defined key_fabm
+               chl_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabmdia_chltot)
+               zsurfvar(:,:) = chl_3d(:,:,1)
+#else
+               CALL ctl_stop( ' Trying to run logchl observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
                llnightav = .FALSE.
-#endif
+               zsurfmask(:,:) = tmask(:,:,1)         ! create a special mask to exclude certain things
+               ! Take the log10 where we can, otherwise exclude
+               tiny = 1.0e-20
+               WHERE(zsurfvar(:,:) > tiny .AND. zsurfvar(:,:) /= obfillflt )
+                  zsurfvar(:,:)  = LOG10(zsurfvar(:,:))
+               ELSEWHERE
+                  zsurfvar(:,:)  = obfillflt
+                  zsurfmask(:,:) = 0
+               END WHERE
+            CASE('spm')
+#if defined key_spm
+               zsurfvar(:,:) = 0.0
+               DO jn = 1, jp_spm
+                  zsurfvar(:,:) = zsurfvar(:,:) + trn(:,:,1,jn)   ! sum SPM sizes
+               END DO
+#else
+               CALL ctl_stop( ' Trying to run spm observation operator', &
+                  &           ' but no spm model appears to have been defined' )
+#endif
+            CASE('fco2')
+#if defined key_hadocc
+               zsurfvar(:,:) = HADOCC_FCO2(:,:)    ! fCO2 from HadOCC
+               IF ( ( MINVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ) .AND. &
+                  & ( MAXVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' HadOCC fCO2 values masked out for observation operator', &
+                     &           ' on timestep ' // TRIM(STR(kstp)),                              &
+                     &           ' as HADOCC_FCO2(:,:) == HADOCC_FILL_FLT' )
+               ENDIF
+#elif defined key_medusa && defined key_foam_medusa
+               zsurfmask(:,:) = MEDUSA_FCO2(:,:)    ! fCO2 from MEDUSA
+               IF ( ( MINVAL( MEDUSA_FCO2 ) == MEDUSA_FILL_FLT ) .AND. &
+                  & ( MAXVAL( MEDUSA_FCO2 ) == MEDUSA_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' MEDUSA fCO2 values masked out for observation operator', &
+                     &           ' on timestep ' // TRIM(STR(kstp)),                              &
+                     &           ' as MEDUSA_FCO2(:,:) == MEDUSA_FILL_FLT' )
+               ENDIF
+#elif defined key_fabm
+               ! First, get pCO2 from FABM
+               pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+               zsurfvar(:,:) = pco2_3d(:,:,1)
+               ! Now, convert pCO2 to fCO2, based on SST in K. This follows the standard methodology of:
+               ! Pierrot et al. (2009), Recommendations for autonomous underway pCO2 measuring systems
+               ! and data reduction routines, Deep-Sea Research II, 56: 512-522.
+               ! and
+               ! Weiss (1974), Carbon dioxide in water and seawater: the solubility of a non-ideal gas,
+               ! Marine Chemistry, 2: 203-215.
+               ! In the implementation below, atmospheric pressure has been assumed to be 1 atm and so
+               ! not explicitly included - atmospheric pressure is not necessarily available so this is
+               ! the best assumption.
+               ! Further, the (1-xCO2)^2 term has been neglected. This is common practice
+               ! (see e.g. Zeebe and Wolf-Gladrow (2001), CO2 in Seawater: Equilibrium, Kinetics, Isotopes)
+               ! because xCO2 in atm is ~0, and so this term will only affect the result to the 3rd decimal
+               ! place for typical values, and xCO2 would need to be approximated from pCO2 anyway.
+               zsurfvar(:,:) = zsurfvar(:,:) * EXP((-1636.75                                                          + &
+                  &            12.0408      * (tsn(:,:,1,jp_tem)+rt0)                                                 - &
+                  &            0.0327957    * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)                         + &
+                  &            0.0000316528 * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0) + &
+                  &            2.0 * (57.7 - 0.118 * (tsn(:,:,1,jp_tem)+rt0)))                                        / &
+                  &            (82.0578 * (tsn(:,:,1,jp_tem)+rt0)))
+#else
+               CALL ctl_stop( ' Trying to run fco2 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+            CASE('pco2')
+#if defined key_hadocc
+               zsurfvar(:,:) = HADOCC_PCO2(:,:)    ! pCO2 from HadOCC
+               IF ( ( MINVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ) .AND. &
+                  & ( MAXVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' HadOCC pCO2 values masked out for observation operator', &
+                     &           ' on timestep ' // TRIM(STR(kstp)),                              &
+                     &           ' as HADOCC_PCO2(:,:) == HADOCC_FILL_FLT' )
+               ENDIF
+#elif defined key_medusa && defined key_foam_medusa
+               zsurfvar(:,:) = MEDUSA_PCO2(:,:)    ! pCO2 from MEDUSA
+               IF ( ( MINVAL( MEDUSA_PCO2 ) == MEDUSA_FILL_FLT ) .AND. &
+                  & ( MAXVAL( MEDUSA_PCO2 ) == MEDUSA_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' MEDUSA pCO2 values masked out for observation operator', &
+                     &           ' on timestep ' // TRIM(STR(kstp)),                              &
+                     &           ' as MEDUSA_PCO2(:,:) == MEDUSA_FILL_FLT' )
+               ENDIF
+#elif defined key_fabm
+               pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+               zsurfvar(:,:) = pco2_3d(:,:,1)
+#else
+               CALL ctl_stop( ' Trying to run pCO2 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
             END SELECT
 
             CALL obs_surf_opt( surfdataqc(jtype), kstp, jpi, jpj,       &
-               &               nit000, idaystp, zsurfvar, tmask(:,:,1), &
+               &               nit000, idaystp, zsurfvar, zsurfmask,    &
                &               nn_2dint, llnightav )
 
@@ -648,4 +894,5 @@
       CALL wrk_dealloc( jpi, jpj, jpk, zprofmask2 )
       CALL wrk_dealloc( jpi, jpj, zsurfvar )
+      CALL wrk_dealloc( jpi, jpj, zsurfmask )
       CALL wrk_dealloc( jpi, jpj, zglam1 )
       CALL wrk_dealloc( jpi, jpj, zglam2 )
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90	(revision 7773)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2.F90	(revision 7773)
@@ -0,0 +1,35 @@
+MODULE obs_fco2
+   !!=====================================================================
+   !!                       ***  MODULE  obs_fco2  ***
+   !! Observation diagnostics: Storage space for fco2 observations
+   !!                          arrays and additional flags etc.
+   !!=====================================================================
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+   
+   !! * Modules used 
+   USE obs_surf_def ! Definition of surface data types and tools
+
+   IMPLICIT NONE
+   
+   SAVE
+
+   !! * Routine accessibility
+   PRIVATE
+
+   PUBLIC nfco2vars, nfco2extr, nfco2sets, fco2data, fco2datqc
+
+   !! * Shared Module variables
+   INTEGER :: nfco2vars                               ! Number of fco2data variables
+   INTEGER :: nfco2extr                               ! Number of fco2data extra 
+                                                      ! variables
+   INTEGER :: nfco2sets                               ! Number of fco2data sets
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: fco2data  ! Initial fco2 data
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: fco2datqc ! Sea ice data after quality control
+
+END MODULE obs_fco2
+
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90	(revision 7773)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_fco2_io.F90	(revision 7773)
@@ -0,0 +1,30 @@
+MODULE obs_fco2_io
+   !!======================================================================
+   !!                       ***  MODULE obs_fco2_io  ***
+   !! Observation operators : I/O for fco2 files
+   !!======================================================================
+   !! History : 
+   !!             !  09-01  (K. Mogensen) Initial version
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   read_fco2file    :  Read a obfbdata structure from a fco2 file
+   !!----------------------------------------------------------------------
+   USE par_kind
+   USE obs_utils
+   USE obs_fbm
+   USE julian
+   USE netcdf
+
+   IMPLICIT NONE
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+#include "obsfco2_io.h90"
+
+END MODULE obs_fco2_io
Index: branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grd_bruteforce.h90
===================================================================
--- branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grd_bruteforce.h90	(revision 7740)
+++ branches/UKMO/dev_r5785_SSS_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grd_bruteforce.h90	(revision 7773)
@@ -325,5 +325,5 @@
          CALL obs_mpp_max_integer( kobsj, kobs )
       ELSE
-         CALL obs_mpp_find_obs_proc( kproc, kobsi, kobsj, kobs )
+         CALL obs_mpp_find_obs_proc( kproc,kobs )
       ENDIF
 
